#include <optional>

#include "peripheral.h"

#pragma once

namespace tuxli {

// Console implements a memory-mapped 16550 UART.
class Console final : public Peripheral {
 public:
  reg_t write(addr_t offset, reg_t value) override;
  reg_t read(addr_t offset) override;

 private:
  bool is_kb_hit();
  std::optional<char> read_kb();

  bool hit_eof_ = false;
};

}  // namespace tuxli
